# osgUtil::Optimizer::FlattenStaticTransformsVisitor Class Reference

Flatten Static Transform nodes by applying their transform to the geometry on the leaves of the scene graph, then removing the now redundant transforms. More...

Inheritance diagram for osgUtil::Optimizer::FlattenStaticTransformsVisitor:

[legend]
List of all members.

## Public Member Functions

| FlattenStaticTransformsVisitor (Optimizer *optimizer=0)
virtual void | apply (osg::Node &geode)
virtual void | apply (osg::Geode &geode)
virtual void | apply (osg::Billboard &geode)
virtual void | apply (osg::Transform &transform)
bool | removeTransforms (osg::Node *nodeWeCannotRemove)
bool | isOperationPermissibleForObject (const osg::Object *object) const

## Protected Types

typedef std::vector< osg::Transform * > | TransformStack
typedef std::set< osg::Drawable * > | DrawableSet
typedef std::set< osg::Billboard * > | BillboardSet
typedef std::set< osg::Node * > | NodeSet
typedef std::set< osg::Transform * > | TransformSet

## Protected Attributes

Optimizer * | _optimizer
TransformStack | _transformStack
NodeSet | _excludedNodeSet
DrawableSet | _drawableSet
BillboardSet | _billboardSet
TransformSet | _transformSet

## Detailed Description

Flatten Static Transform nodes by applying their transform to the geometry on the leaves of the scene graph, then removing the now redundant transforms.

## Member Typedef Documentation

typedef std::set<osg::Billboard*> osgUtil::Optimizer::FlattenStaticTransformsVisitor::BillboardSet `[protected]`

typedef std::set<osg::Drawable*> osgUtil::Optimizer::FlattenStaticTransformsVisitor::DrawableSet `[protected]`

typedef std::set<osg::Node* > osgUtil::Optimizer::FlattenStaticTransformsVisitor::NodeSet `[protected]`

typedef std::set<osg::Transform*> osgUtil::Optimizer::FlattenStaticTransformsVisitor::TransformSet `[protected]`

typedef std::vector<osg::Transform*> osgUtil::Optimizer::FlattenStaticTransformsVisitor::TransformStack `[protected]`

## Constructor & Destructor Documentation

osgUtil::Optimizer::FlattenStaticTransformsVisitor::FlattenStaticTransformsVisitor | ( | Optimizer * | optimizer = `0` | ) | `[inline]`

## Member Function Documentation

void Optimizer::FlattenStaticTransformsVisitor::apply | ( | osg::Transform & | transform | ) | `[virtual]`

void Optimizer::FlattenStaticTransformsVisitor::apply | ( | osg::Billboard & | geode | ) | `[virtual]`

void Optimizer::FlattenStaticTransformsVisitor::apply | ( | osg::Geode & | geode | ) | `[virtual]`

void Optimizer::FlattenStaticTransformsVisitor::apply | ( | osg::Node & | geode | ) | `[virtual]`

bool osgUtil::Optimizer::FlattenStaticTransformsVisitor::isOperationPermissibleForObject | ( | const osg::Object * | object | ) | const`[inline]`

bool Optimizer::FlattenStaticTransformsVisitor::removeTransforms | ( | osg::Node * | nodeWeCannotRemove | ) |

## Member Data Documentation

BillboardSet osgUtil::Optimizer::FlattenStaticTransformsVisitor::_billboardSet `[protected]`

DrawableSet osgUtil::Optimizer::FlattenStaticTransformsVisitor::_drawableSet `[protected]`

NodeSet osgUtil::Optimizer::FlattenStaticTransformsVisitor::_excludedNodeSet `[protected]`

Optimizer* osgUtil::Optimizer::FlattenStaticTransformsVisitor::_optimizer `[protected]`

TransformSet osgUtil::Optimizer::FlattenStaticTransformsVisitor::_transformSet `[protected]`

TransformStack osgUtil::Optimizer::FlattenStaticTransformsVisitor::_transformStack `[protected]`

The documentation for this class was generated from the following files:

- Optimizer
- Optimizer.cpp